=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'uri'

module WeFitter
  class InsightsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get someones biological age on a weekly basis.
    # 
    # @param start_date 
    # @param end_date 
    # @param [Hash] opts the optional parameters
    # @return [Array<BioAge>]
    def insights_bio_age_read(start_date, end_date, opts = {})
      data, _status_code, _headers = insights_bio_age_read_with_http_info(start_date, end_date, opts)
      data
    end

    # Get someones biological age on a weekly basis.
    # 
    # @param start_date 
    # @param end_date 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<BioAge>, Fixnum, Hash)>] Array<BioAge> data, response status code and response headers
    def insights_bio_age_read_with_http_info(start_date, end_date, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InsightsApi.insights_bio_age_read ...'
      end
      # verify the required parameter 'start_date' is set
      if @api_client.config.client_side_validation && start_date.nil?
        fail ArgumentError, "Missing the required parameter 'start_date' when calling InsightsApi.insights_bio_age_read"
      end
      # verify the required parameter 'end_date' is set
      if @api_client.config.client_side_validation && end_date.nil?
        fail ArgumentError, "Missing the required parameter 'end_date' when calling InsightsApi.insights_bio_age_read"
      end
      # resource path
      local_var_path = '/insights/bio_age'

      # query parameters
      query_params = {}
      query_params[:'start_date'] = start_date
      query_params[:'end_date'] = end_date

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<BioAge>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InsightsApi#insights_bio_age_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
